<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides access to HighCharts Series Column Data Types
 *
 * @package    HighChart/Types
 * @category   Helper
 * @author     Deon George
 * @copyright  (c) 2012-2013 Deon George
 * @license    http://dev.leenooks.net/license.html
 */
class HighChart_Type_Pie extends HighChart_Type {
	protected $_ssize = 100;
	protected $_scenter = array(100,100);
	protected $_type = 'pie';

	public function __call($name,$args) {
		switch ($name) {
			case 'center':
				if (! $args)
					return $this->_ssize;

				$this->_scenter = $args;
				break;

			case 'size':
				if (! $args)
					return $this->_ssize;

				$this->_ssize = array_shift($args);
				break;

			default: return parent::__call($name,$args);
		}

		return $this;
	}


	public function as_array(array $options=array()) {
		$result = array();
		$result['data'] = array();

		$c = 0;
		foreach ($this->_sdata as $k=>$v) {
			$result['data'][$c]['y'] = $v;
			$result['data'][$c]['name'] = $k;

			if (isset($this->_soptions['color'][$k]))
				$result['data'][$c]['color'] = $this->_soptions['color'][$k];

			$c++;
		}

		$result['size'] = $this->_ssize;
		$result['type'] = $this->_type;
		$result['center'] = $this->_scenter;

		$result['showInLegend'] = FALSE;
		$result['dataLabels'] = array('enabled'=>FALSE);

		return $result;
	}
}
